<?php

require_once 'phpgen_settings.php';
require_once 'components/security/security_info.php';
require_once 'components/security/datasource_security_info.php';
require_once 'components/security/tablebased_auth.php';
require_once 'components/security/user_grants_manager.php';
require_once 'components/security/table_based_user_grants_manager.php';

require_once 'database_engine/mysql_engine.php';

$grants = array('guest' => 
        array()
    ,
    'defaultUser' => 
        array('alarms' => new DataSourceSecurityInfo(true, true, true, true),
        'answered_alarms' => new DataSourceSecurityInfo(true, false, false, true),
        'unsuccessful_alarms' => new DataSourceSecurityInfo(true, false, false, true),
        'langs' => new DataSourceSecurityInfo(true, false, false, false),
        'voip_account' => new DataSourceSecurityInfo(false, false, false, false),
        'settings' => new DataSourceSecurityInfo(true, false, false, false),
        'users' => new DataSourceSecurityInfo(false, false, false, false))
    ,
    'admin' => 
        array('alarms' => new AdminDataSourceSecurityInfo(),
        'answered_alarms' => new AdminDataSourceSecurityInfo(),
        'unsuccessful_alarms' => new AdminDataSourceSecurityInfo(),
        'langs' => new AdminDataSourceSecurityInfo(),
        'voip_account' => new AdminDataSourceSecurityInfo(),
        'settings' => new AdminDataSourceSecurityInfo(),
        'users' => new AdminDataSourceSecurityInfo())
    ,
    'user' => 
        array('alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'answered_alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'unsuccessful_alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'langs' => new DataSourceSecurityInfo(false, false, false, false),
        'voip_account' => new DataSourceSecurityInfo(false, false, false, false),
        'settings' => new DataSourceSecurityInfo(false, false, false, false),
        'users' => new DataSourceSecurityInfo(false, false, false, false))
    ,
    'user2' => 
        array('alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'answered_alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'unsuccessful_alarms' => new DataSourceSecurityInfo(false, false, false, false),
        'langs' => new DataSourceSecurityInfo(false, false, false, false),
        'voip_account' => new DataSourceSecurityInfo(false, false, false, false),
        'settings' => new DataSourceSecurityInfo(false, false, false, false),
        'users' => new DataSourceSecurityInfo(false, false, false, false))
    );

$appGrants = array('guest' => new DataSourceSecurityInfo(false, false, false, false),
    'defaultUser' => new DataSourceSecurityInfo(false, false, false, false),
    'admin' => new AdminDataSourceSecurityInfo(),
    'user' => new DataSourceSecurityInfo(false, false, false, false),
    'user2' => new DataSourceSecurityInfo(false, false, false, false));

$dataSourceRecordPermissions = array();

$tableCaptions = array('alarms' => 'alarms',
'answered_alarms' => 'answered_alarms',
'unsuccessful_alarms' => 'unsuccessful_alarms',
'langs' => 'langs',
'voip_account' => 'voip_account',
'settings' => 'settings',
'users' => 'users');

function CreateTableBasedGrantsManager()
{
    return null;
}

function SetUpUserAuthorization()
{
    global $grants;
    global $appGrants;
    global $dataSourceRecordPermissions;
    $hardCodedGrantsManager = new HardCodedUserGrantsManager($grants, $appGrants);
$tableBasedGrantsManager = CreateTableBasedGrantsManager();
$grantsManager = new CompositeGrantsManager();
$grantsManager->AddGrantsManager($hardCodedGrantsManager);
if (!is_null($tableBasedGrantsManager))
    $grantsManager->AddGrantsManager($tableBasedGrantsManager);
$userAuthorizationStrategy = new TableBasedUserAuthorization(new MyConnectionFactory(), GetGlobalConnectionOptions(), 'users', 'user_name', 'user_id', $grantsManager);
    GetApplication()->SetUserAuthorizationStrategy($userAuthorizationStrategy);

GetApplication()->SetDataSourceRecordPermissionRetrieveStrategy(
    new HardCodedDataSourceRecordPermissionRetrieveStrategy($dataSourceRecordPermissions));
}

function GetIdentityCheckStrategy()
{
    return new TableBasedIdentityCheckStrategy(new MyConnectionFactory(), GetGlobalConnectionOptions(), 'users', 'user_name', 'user_password', ENCRYPTION_NONE);
}

?>